<?php

/**
 * Description of ajax
 *
 * @author Artem Yuriev art3mk4@gmail.com Dec 13, 2018 11:57:19 AM
 */
if (!defined('ADSGOOGLECATALOG_PATH')) define('ADSGOOGLECATALOG_PATH', __DIR__);
if (!defined('ADSGOOGLECONFIG_PATH')) define('ADSGOOGLECONFIG_PATH', dirname(dirname(dirname(__DIR__))));
if (!defined('ABSPATH')) define('ABSPATH', dirname(dirname(__DIR__)));
require_once 'progress/autoload.php';
$fileLoad = progress\models\ConfigGoogle::loadFile();
if ($fileLoad) {
    progress\models\Settings::init();
    $params = '';
    if (isset($_POST['args'])) {
        $params = $_POST['args'];
    }

    if (isset($_POST['categories'])) {
        $stringCategories = implode(', ', $_POST['categories']);
        $params.= '&category=' . $stringCategories;
    }

    if (isset($_POST['current_page'])) {
        $params.= '&current_page=' . $_POST['current_page'];
    }

    try {
        $googleProcess = new progress\models\GoogleProcess($params);
        $status = $googleProcess->getStatus();
    } catch (RuntimeException $exc) {
        echo json_encode(
            array(
                'result' => false,
                'message' => $exc->getMessage()
            )
        );
        die();
    }

    echo json_encode(
        array(
            'result'  => true,
            'message' => 'Process has been started successfully.',
            'status'  => $status
        )
    );
} else {
    echo json_encode(
        array(
            'result' => false,
            'message' => 'Can\'t load settings file.'
        )
    );
}