<?php

namespace progress\models;
use progress\models\pdo\MysqlPDO as MysqlPDO;

/**
 * Description of Process
 *
 * @author Artem Yuriev art3mk4@gmail.com Nov 28, 2018 3:31:23 PM
 */
class Process extends MysqlPDO
{

    /**
     * INPROGRESS
     */
    const INPROGRESS = 0;

    /**
     * ERROR
     */
    const ERROR = 1;

    /**
     * DONE
     */
    const DONE = 2;

    /**
     * _id
     * 
     * @var type 
     */
    private $_id;

    /**
     * _pid
     * 
     * @var type 
     */
    private $_pid;

    /**
     * _status
     * 
     * @var type 
     */
    private $_status;

    /**
     * _progress
     * 
     * @var type 
     */
    private $_progress;

    /**
     * _start_time
     * 
     * @var type 
     */
    private $_start_time;

    /**
     * _finish_time
     * 
     * @var type 
     */
    private $_finish_time;

    /**
     * _current_page
     * 
     * @var type 
     */
    private $_current_page;

    /**
     * _total_page
     * 
     * @var type 
     */
    private $_total_page;

    /**
     * construct
     */
    public function __construct()
    {
        $this->setTable('ads_google_processes');
        parent::__construct();
    }

    /**
     * count
     */
    public function count()
    {
        $select = $this->prepare('SELECT COUNT(*) as count FROM ' . TABLE_PREFIX . $this->table);
        $select->execute();
        $result = $select->fetch(\PDO::FETCH_ASSOC);
        if (!isset($result['count'])) {
            return 0;
        }

        return $result['count'];
    }

    /**
     * find
     * 
     * @param type $arguments
     * @param type $table
     */
    public function find($arguments = array(), $table = '')
    {
        $select = $this->prepare("SELECT * FROM " . TABLE_PREFIX . $this->table . " ORDER BY ID DESC");
        $select->execute();
        $result = $select->fetch(\PDO::FETCH_ASSOC);
        return $result;
    }

    /**
     * delete
     * 
     * @param type $arguments
     */
    public function delete($arguments = array(), $table = '')
    {
        parent::delete($arguments, $this->table);
    }

    /**
     * getStatuses
     * 
     * @return type
     */
    public function getStatuses()
    {
        return array(
            self::INPROGRESS => 'in_progress',
            self::ERROR      => 'error',
            self::DONE       => 'done'
        );
    }

    /**
     * getId
     * 
     * @return type
     */
    public function getId()
    {
        return $this->_id;
    }

    /**
     * getPid
     * 
     * @return type
     */
    public function getPid()
    {
        return $this->_pid;
    }

    /**
     * getStatus
     * 
     * @return type
     */
    public function getStatus()
    {
        return $this->_status;
    }

    /**
     * getProgress
     * 
     * @return type
     */
    public function getProgress()
    {
        return $this->_progress;
    }

    /**
     * getStart_time
     * 
     * @return type
     */
    public function getStart_time()
    {
        return $this->_start_time;
    }

    /**
     * getFinish_time
     * 
     * @return type
     */
    public function getFinish_time()
    {
        return $this->_finish_time;
    }

    /**
     * getCurrent_page
     * 
     * @return type
     */
    public function getCurrent_page()
    {
        return $this->_current_page;
    }

    /**
     * getTotal_page
     * 
     * @return type
     */
    public function getTotal_page()
    {
        return $this->_total_page;
    }

    /**
     * setId
     * 
     * @param type $id
     */
    public function setId($id)
    {
        $this->_id = $id;
    }

    /**
     * setPid
     * 
     * @param type $pid
     */
    public function setPid($pid)
    {
        $this->_pid = $pid;
    }

    /**
     * setStatus
     * 
     * @param type $status
     */
    public function setStatus($status)
    {
        $this->_status = $status;
    }

    /**
     * setProgress
     * 
     * @param type $progress
     */
    public function setProgress($progress)
    {
        $this->_progress = $progress;
    }

    /**
     * setStart_time
     * 
     * @param type $start_time
     */
    public function setStart_time($start_time)
    {
        $this->_start_time = $start_time;
    }

    /**
     * setFinish_time
     * 
     * @param type $finish_time
     */
    public function setFinish_time($finish_time)
    {
        $this->_finish_time = $finish_time;
    }

    /**
     * setCurrent_page
     * 
     * @param type $current_page
     */
    public function setCurrent_page($current_page)
    {
        $this->_current_page = $current_page;
    }

    /**
     * setTotal_page
     * 
     * @param type $total_page
     */
    public function setTotal_page($total_page)
    {
        $this->_total_page = $total_page;
    }
}